<?xml version="1.0" encoding="UTF-8"?>
<databaseChangeLog
    xmlns="http://www.liquibase.org/xml/ns/dbchangelog"
    xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
    xsi:schemaLocation="http://www.liquibase.org/xml/ns/dbchangelog
                      http://www.liquibase.org/xml/ns/dbchangelog/dbchangelog-3.1.xsd">

  <changeSet id="db-changelog-init-1" author="hojeda" dbms="h2">
  	<preConditions onFail="MARK_RAN">
  		<not>
 	 		<tableExists tableName="galaxy"/>
  		</not>
  	</preConditions>
  	<createTable tableName="galaxy">
  		<column name="id" type="bigint" autoIncrement="true">
  			<constraints nullable="false" primaryKey="true"/>
  		</column>
  		<column name="name" type="varchar(255)">
  			<constraints nullable="false"/>
  		</column>
  	</createTable>
  </changeSet>
  
  <changeSet id="db-changelog-init-2" author="hojeda" dbms="h2">
  	<preConditions onFail="MARK_RAN">
  		<not>
 	 		<tableExists tableName="planet"/>
  		</not>
  	</preConditions>
  	<createTable tableName="planet">
  		<column name="id" type="bigint" autoIncrement="true">
  			<constraints nullable="false" primaryKey="true"/>
  		</column>
  		<column name="name" type="varchar(255)">
  			<constraints nullable="false"/>
  		</column>
  		<column name="sun_distance" type="decimal(19,4)" autoIncrement="true">
  			<constraints nullable="false" primaryKey="true"/>
  		</column>
  		<column name="angular_velocity" type="decimal(19,4)" autoIncrement="true">
  			<constraints nullable="false" primaryKey="true"/>
  		</column>
  		<column name="turning_sense" type="tinyint">
  			<constraints nullable="false"/>
  		</column>
		<column name="galaxy_id" type="bigint" autoIncrement="true">
  			<constraints nullable="false" primaryKey="true"/>
  		</column>
  	</createTable>
	<addForeignKeyConstraint constraintName="fk_planet_galaxy" 
		baseTableName="planet" 
		baseColumnNames="galaxy_id" 
		referencedTableName="galaxy" 
		referencedColumnNames="id"/>
  </changeSet>
  
  <changeSet id="db-changelog-init-3" author="hojeda" dbms="h2">
  	<preConditions onFail="MARK_RAN">
  		<not>
 	 		<tableExists tableName="weather_condition"/>
  		</not>
  	</preConditions>
  	<createTable tableName="weather_condition">
  		<column name="id" type="bigint" autoIncrement="true">
  			<constraints nullable="false" primaryKey="true"/>
  		</column>
  		<column name="description" type="varchar(255)">
  			<constraints nullable="false"/>
  		</column>
  		<column name="type" type="varchar(255)">
  			<constraints nullable="false"/>
  		</column>
  	</createTable>
  </changeSet>
  
  <changeSet id="db-changelog-init-4" author="hojeda">
  	<preConditions onFail="MARK_RAN">
  		<not>
 	 		<tableExists tableName="coordinate"/>
  		</not>
  	</preConditions>
  	<createTable tableName="coordinate">
  		<column name="id" type="bigint" autoIncrement="true">
  			<constraints nullable="false" primaryKey="true"/>
  		</column>
  		<column name="x" type="decimal(19,4)">
  			<constraints nullable="false"/>
  		</column>
  		<column name="y" type="decimal(19,4)">
  			<constraints nullable="false"/>
  		</column>
  		<column name="incline" type="decimal(19,4)">
  			<constraints nullable="true"/>
  		</column>
  		<column name="degrees" type="decimal(19,4)">
  			<constraints nullable="false"/>
  		</column>
  		<column name="day" type="bigint">
  			<constraints nullable="false"/>
  		</column>
  		<column name="planet_id" type="bigint">
  			<constraints nullable="false"/>
  		</column>
  	</createTable>
  	<addUniqueConstraint columnNames="day,planet_id" tableName="coordinate"/>
  	<addForeignKeyConstraint constraintName="fk_coordinate_planet" 
	  	baseTableName="coordinate" 
	  	baseColumnNames="planet_id" 
	  	referencedTableName="planet" 
	  	referencedColumnNames="id"/>
  </changeSet>
  
  <changeSet id="db-changelog-init-5" author="hojeda">
  	<preConditions onFail="MARK_RAN">
  		<not>
 	 		<tableExists tableName="weather_prediction"/>
  		</not>
  	</preConditions>
  	<createTable tableName="weather_prediction">
  		<column name="id" type="bigint(20)" autoIncrement="true">
  			<constraints nullable="false" primaryKey="true"/>
  		</column>
  		<column name="weather_condition_id" type="bigint">
  			<constraints nullable="false"/>
  		</column>
  		<column name="coordinate_id" type="bigint">
  			<constraints nullable="false"/>
  		</column>
  		<column name="triangle_perimeter" type="decimal(19,4)">
  			<constraints nullable="true"/>
  		</column>
  	</createTable>
  	<addForeignKeyConstraint constraintName="fk_wp_coordinate" 
  		baseTableName="weather_prediction" 
  		baseColumnNames="coordinate_id" 
  		referencedTableName="coordinate" 
  		referencedColumnNames="id"/>
  	<addForeignKeyConstraint constraintName="fk_wp_weather_condition" 
  		baseTableName="weather_prediction" 
  		baseColumnNames="weather_condition_id" 
  		referencedTableName="weather_condition" 
  		referencedColumnNames="id"/>
  </changeSet>

</databaseChangeLog>